"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ArrayGenotypingRate(ProtocolElement):
    """
    Array genotyping rate for the sample * `IID`  Individual sample ID *
    `number_missing_genotypes`: The number of missing genotypes *
    `number_total_genotypes`: The number of total genotypes
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "IID",
        "number_missing_genotypes",
        "number_total_genotypes",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_1 import metrics as metrics_1_2_3

        return {
            "org.gel.models.report.avro.ArrayGenotypingRate": metrics_1_2_3.ArrayGenotypingRate,
        }

    __slots__ = [
        "IID",
        "number_missing_genotypes",
        "number_total_genotypes",
    ]

    def __init__(
        self,
        IID,
        number_missing_genotypes,
        number_total_genotypes,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_3.ArrayGenotypingRate model.

        :param IID:
        :type IID: str
        :param number_missing_genotypes:
        :type number_missing_genotypes: double
        :param number_total_genotypes:
        :type number_total_genotypes: double
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.3"
